//
//  SC01Employer.m
//  PrimerSample
//
//  Created by Jp LaFond on 3/19/12.
//  Copyright (c) 2012 Jp4Mobile. All rights reserved.
//

#import "SC01Employer.h"

@implementation SC01Employer

// Synthesize our internal variables
@synthesize companyName = _companyName;
@synthesize employees   = _employees;
@synthesize projects    = _projects;

// Our methods
- (id) initWithCompanyName:(NSString *)companyName EmployeesArray:(NSMutableArray *)employeesArray ProjectsDictionary:(NSMutableDictionary *)projectionsDictionary {
    // Initialize
    self = [super init];
    // Populate
    self.companyName = companyName;
    self.employees   = employeesArray;
    self.projects    = projectionsDictionary;
    
    return self;
}

// Our helper methods
- (void) addEmployees {
    // Check to see if it's not present
    if (nil == self.employees) {
        // Create it with a capacity that's a bland default
        self.employees = [[NSMutableArray alloc] initWithCapacity:10];
    }
    // Add some random people
    [self.employees addObject:[[SC01Person alloc] initWithFirstName:@"Abe" LastName:@"Able" HUID:11111]];
    
    [self.employees addObject:[[SC01Person alloc] initWithFirstName:@"Bob" LastName:@"Baker" HUID:22222]];

    [self.employees addObject:[[SC01Person alloc] initWithFirstName:@"Chet" LastName:@"Charlie" HUID:33333]];
    
    [self.employees addObject:[[SC01Person alloc] initWithFirstName:@"Doug" LastName:@"Delta" HUID:44444]];
}

- (void) addProjects:(NSString *)projectName ProjectLead:(SC01Person *)projectLead {
    // Check to see if it's not present
    if (nil == self.projects) {
        // Create it with a capacity that's a bland default
        self.projects = [[NSMutableDictionary alloc] initWithCapacity:10];
    }
    // Add our data
    [self.projects setValue:projectLead forKey:projectName];
}

- (void) printEmployees {
    // Check to see if the employees array is empty
    if (0 == self.employees.count) {
        NSLog(@" employee[] empty");
    }
    // For loop to walk the array
    //     always a good idea to keep from querying an array or dictionary for size more than once
    for (int i = 0, len = self.employees.count; i < len; i++) {
        // Get the record to make things easier, when we...
        SC01Person * tmpPerson = [self.employees objectAtIndex:i];
        // Print it out
        NSLog(@" employee[%d] (%@ %@) <%d>", i, tmpPerson.firstName, tmpPerson.lastName, tmpPerson.huidNumber);
    }
}

- (void) printProjects {
    // Check to see if the projects dictionary is empty
    if (0 == self.projects.count) {
        NSLog(@" (%@) projects are empty", self.companyName);
    } else {
        NSLog(@" Projects for (%@)", self.companyName);
    }
    NSArray * projectKeys = self.projects.allKeys;
    for (NSString * key in projectKeys) {
        // Classic do as I say, not as I do, this is a way of piling on to send the message to get the lastNamme without verifying the class before you send the message
        NSLog(@" key (%@) value (%@)", key, [[self.projects objectForKey:key] lastName]);
    }
}

@end
